/************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER
 *
 * Copyright 2008, 2010 Oracle and/or its affiliates. All rights reserved.
 *
 * Use is subject to license terms.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy
 * of the License at http://www.apache.org/licenses/LICENSE-2.0. You can also
 * obtain a copy of the License at http://odftoolkit.org/docs/license.txt
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************************/

/*
 * This file is automatically generated.
 * Don't edit manually.
 */    

package org.odftoolkit.odfdom.dom.element.db;

import org.odftoolkit.odfdom.OdfName;
import org.odftoolkit.odfdom.OdfNamespace;
import org.odftoolkit.odfdom.OdfFileDom;
import org.odftoolkit.odfdom.dom.OdfNamespaceNames;
import org.odftoolkit.odfdom.OdfElement;


/**
 * DOM implementation of OpenDocument element  {@odf.element db:connection-data}.
 *
 */
public class DbConnectionDataElement extends OdfElement
{        
    public static final OdfName ELEMENT_NAME = OdfName.newName(OdfNamespaceNames.DB, "connection-data" );


	/**
	 * Create the instance of <code>DbConnectionDataElement</code> 
	 *
	 * @param  ownerDoc     The type is <code>OdfFileDom</code>
	 */
	public DbConnectionDataElement( OdfFileDom ownerDoc )
	{
		super( ownerDoc, ELEMENT_NAME	);
	}

	/**
	 * Get the element name 
	 *
	 * @return  return   <code>OdfName</code> the name of element {@odf.element db:connection-data}.
	 */
	public OdfName getOdfName()
	{
		return ELEMENT_NAME;
	}


	/**
	 * Create child element {@odf.element db:database-description}.
	 *
	 * @return   return  the element {@odf.element db:database-description}
	 * DifferentQName 
	 */
	public DbDatabaseDescriptionElement newDbDatabaseDescriptionElement()
	{
		DbDatabaseDescriptionElement  dbDatabaseDescription = ((OdfFileDom)this.ownerDocument).newOdfElement(DbDatabaseDescriptionElement.class);
		this.appendChild( dbDatabaseDescription);
		return  dbDatabaseDescription;
	}                   
               
	/**
	 * Create child element {@odf.element db:connection-resource}.
	 *
     * @param xlinkHrefAttributeValue  the <code>String</code> value of <code>XlinkHrefAttribute</code>, see {@odf.attribute  xlink:href} at specification
	 * @param xlinkTypeAttributeValue  the <code>String</code> value of <code>XlinkTypeAttribute</code>, see {@odf.attribute  xlink:type} at specification
	 * @return   return  the element {@odf.element db:connection-resource}
	 * DifferentQName 
	 */
    
	public DbConnectionResourceElement newDbConnectionResourceElement(String xlinkHrefAttributeValue, String xlinkTypeAttributeValue)
	{
		DbConnectionResourceElement  dbConnectionResource = ((OdfFileDom)this.ownerDocument).newOdfElement(DbConnectionResourceElement.class);
		dbConnectionResource.setXlinkHrefAttribute( xlinkHrefAttributeValue );
		dbConnectionResource.setXlinkTypeAttribute( xlinkTypeAttributeValue );
		this.appendChild( dbConnectionResource);
		return  dbConnectionResource;      
	}
    
	/**
	 * Create child element {@odf.element db:login}.
	 *
	 * @return   return  the element {@odf.element db:login}
	 * DifferentQName 
	 */
	public DbLoginElement newDbLoginElement()
	{
		DbLoginElement  dbLogin = ((OdfFileDom)this.ownerDocument).newOdfElement(DbLoginElement.class);
		this.appendChild( dbLogin);
		return  dbLogin;
	}                   
               
}
